unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ShellCtrls, StdCtrls, ExtCtrls, Psock, NMFtp, Buttons,
  Grids, ShellApi, Outline, DirOutln, ImgList, Menus, ToolWin;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Panel2: TPanel;
    ShellListView1: TShellListView;
    ShellComboBox1: TShellComboBox;
    NMFTP1: TNMFTP;
    ListBox1: TListBox;
    ListBox2: TListBox;
    Label1: TLabel;
    Label2: TLabel;
    StatusBar1: TStatusBar;
    ListBox3: TListBox;
    ImageList1: TImageList;
    PopupMenu1: TPopupMenu;
    DEscargar1: TMenuItem;
    Renombrar1: TMenuItem;
    Eliminar1: TMenuItem;
    PopupMenu2: TPopupMenu;
    RenombrarDirectorio1: TMenuItem;
    EliminarDirectorio1: TMenuItem;
    CrearDirectorio1: TMenuItem;
    CoolBar1: TCoolBar;
    Panel1: TPanel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    Panel3: TPanel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    MainMenu1: TMainMenu;
    ClienteFTP1: TMenuItem;
    Conectar1: TMenuItem;
    Desconectar1: TMenuItem;
    Cargar1: TMenuItem;
    Descargar2: TMenuItem;
    Acercade1: TMenuItem;
    Salir1: TMenuItem;
    procedure SpeedButton1Click(Sender: TObject);
    procedure NMFTP1AuthenticationFailed(var Handled: Boolean);
    procedure NMFTP1Connect(Sender: TObject);
    procedure NMFTP1ConnectionFailed(Sender: TObject);
    procedure NMFTP1Disconnect(Sender: TObject);
    procedure NMFTP1HostResolved(Sender: TComponent);
    procedure SpeedButton2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Directorios;
    procedure ListBox1DblClick(Sender: TObject);
    procedure ListBox2Click(Sender: TObject);
    procedure ListBox2DblClick(Sender: TObject);
    procedure NMFTP1PacketRecvd(Sender: TObject);
    procedure DEscargar1Click(Sender: TObject);
    procedure Renombrar1Click(Sender: TObject);
    procedure Eliminar1Click(Sender: TObject);
    procedure RenombrarDirectorio1Click(Sender: TObject);
    procedure EliminarDirectorio1Click(Sender: TObject);
    procedure CrearDirectorio1Click(Sender: TObject);
    procedure NMFTP1PacketSent(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure Salir1Click(Sender: TObject);
    procedure Conectar1Click(Sender: TObject);
    procedure Desconectar1Click(Sender: TObject);
    procedure Cargar1Click(Sender: TObject);
    procedure Descargar2Click(Sender: TObject);
    procedure Acercade1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Directorios;
var i: Integer;
begin
  Memo1.Lines.Add('Generando lista de Archivos y Directorios . . .');
  ListBox1.Items.Clear;
  ListBox1.Items.Add( '..' );
  ListBox2.Items.Clear;
  NMFTP1.ParseList := True;
  NMFTP1.Vendor := NMOS_AUTO;
  NMFTP1.List;

  for i := 0 to NMFTP1.FTPDirectoryList.Name.Count - 1 do
    if NMFTP1.FTPDirectoryList.Attribute[i][1] = 'd' then
      ListBox1.Items.Add( NMFTP1.FTPDirectoryList.Name[i] )
    else
      ListBox2.Items.Add( NMFTP1.FTPDirectoryList.Name[i] );
  Memo1.Lines.Add('Lista Terminada . . .');
end;


procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  NMFTP1.Host := Edit1.Text;
  NMFTP1.Port := StrToInt(Edit4.Text);
  NMFTP1.Timeout := 5000;
  NMFTP1.UserID := Edit2.Text;
  NMFTP1.Password := Edit3.Text;
  Try
  begin
    NMFTP1.Connect;
    Directorios;
  end
  Except
    Memo1.Lines.Add('Error duarnte la conexion');
  end;

end;

procedure TForm1.NMFTP1AuthenticationFailed(var Handled: Boolean);
begin
Memo1.Lines.Add('Pasword Incorrecto, Intente de nuevo');
end;

procedure TForm1.NMFTP1Connect(Sender: TObject);
begin
Memo1.Lines.Add('Conexion establecida');
Directorios;
end;

procedure TForm1.NMFTP1ConnectionFailed(Sender: TObject);
begin
Memo1.Lines.Add('No se puede conectar con el Sitio.');
end;

procedure TForm1.NMFTP1Disconnect(Sender: TObject);
begin
 Memo1.Lines.Add('Desconectado del Sitio . . .')
end;

procedure TForm1.NMFTP1HostResolved(Sender: TComponent);
begin
Memo1.Lines.Add('EL Host esta atendiendo la peticion . . .');
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
if NMFTP1.Connected then
   NMFTP1.Disconnect;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 if NMFTP1.Connected then
    NMFTP1.Disconnect;
end;

procedure TForm1.ListBox1DblClick(Sender: TObject);
begin
  Memo1.Lines.Add('Cambiando al directorio ' + ListBox1.Items[ListBox1.ItemIndex]);
  NMFTP1.ChangeDir(ListBox1.Items[ListBox1.ItemIndex] );
  Directorios;
end;

procedure TForm1.ListBox2Click(Sender: TObject);
begin
 StatusBar1.SimpleText := 'Tamao: ' +
    FormatFloat( '###,###,###,##0',
      StrToFloat( NMFTP1.FTPDirectoryList.Size[ListBox2.ItemIndex] ) ) + ' bytes ' +        'Fecha: ' + NMFTP1.FTPDirectoryList.ModifDate[ListBox2.ItemIndex];

end;

procedure TForm1.ListBox2DblClick(Sender: TObject);
Var Ruta : String;
begin
if (ListBox2.Count > 0) then
begin
  Ruta :=  ShellComboBox1.Path + '\';
  ListBox3.Items.Add('Descarga....  ' + ListBox2.Items[ListBox2.ItemIndex]);
  Ruta := Ruta + ListBox2.Items[ListBox2.ItemIndex];
  NMFTP1.Mode( MODE_IMAGE );
  Try
  begin
   NMFTP1.Download( ListBox2.Items[ListBox2.ItemIndex],Ruta);
   Memo1.Lines.Add('Descarga Terminada . . .');
   StatusBar1.SimpleText := 'Descarga Terminada . . .';
  end
  Except
     Memo1.Lines.Add('Error duarnte la Descarga . . .');
     if Application.MessageBox('Error al descargar, Desea Resumir la descraga ?','DESCARGA',MB_OKCANCEL+MB_ICONQUESTION) = IDOK then
     begin
       Memo1.Lines.Add('Resumiendo la Descarga Fallida . . .');
       NMFTP1.DownloadRestore( ListBox2.Items[ListBox2.ItemIndex],Ruta);
       Memo1.Lines.Add('Descarga Terminada . . .');
       StatusBar1.SimpleText := 'Descarga Terminada . . .';
     end;
  end;
end;
end;

procedure TForm1.NMFTP1PacketRecvd(Sender: TObject);
begin
  StatusBar1.SimpleText := 'Descargando: ' + ListBox2.Items[ListBox2.ItemIndex]+ ' ' + IntToStr(NMFTP1.BytesRecvd)+' of '+IntToStr(NMFTP1.BytesTotal);
end;

procedure TForm1.DEscargar1Click(Sender: TObject);
begin
Form1.ListBox2DblClick(Sender);
end;

procedure TForm1.Renombrar1Click(Sender: TObject);
var
   Actual, Anterior : String;
begin

if (ListBox2.Count > 0) then
begin
  Anterior := ListBox2.Items[ListBox2.ItemIndex];

  if InputQuery('Renombrar Archivo', 'Nuebo Nombre ?', Actual) then
  begin
      NMFTP1.Rename(Anterior,Actual);
      Memo1.Lines.Add('Archivo Renombrado . . .');
      Directorios;
  end;
end;
end;

procedure TForm1.Eliminar1Click(Sender: TObject);
var Archivo : String;
begin
if (ListBox2.Count > 0) then
begin
  Archivo := ListBox2.Items[ListBox2.ItemIndex];
  if Application.MessageBox('Esta seguro de Eliminar el Archivo ?','ELIMINAR',MB_OKCANCEL+MB_ICONQUESTION) = IDOK then
  begin
     NMFTP1.Delete(Archivo);
     Memo1.Lines.Add('Archivo eliminado . . .');
     Directorios;
  end;
end;
end;

procedure TForm1.RenombrarDirectorio1Click(Sender: TObject);
var Anterior, Actual : String;
begin
if (ListBox1.Count > 1) then
begin
  Anterior := ListBox1.Items[ListBox1.ItemIndex];

  if InputQuery('Renombrar Directorio', 'Nuebo Nombre ?', Actual) then
  begin
      NMFTP1.Rename(Anterior,Actual);
      Memo1.Lines.Add('Directorio Renombrado . . .');
      Directorios;
  end;
end;

end;

procedure TForm1.EliminarDirectorio1Click(Sender: TObject);
Var Dir : String;
begin
if (ListBox1.Count > 0) then
begin
  Dir := ListBox1.Items[ListBox1.ItemIndex];
  if Application.MessageBox('Esta seguro de Eliminar el Directorio ?','ELIMINAR',MB_OKCANCEL+MB_ICONQUESTION) = IDOK then
  begin
     NMFTP1.RemoveDir(Dir);
     Memo1.Lines.Add('Directorio Eliminado . . .');
     Directorios;
  End;
end;

end;

procedure TForm1.CrearDirectorio1Click(Sender: TObject);
var Dir : String;
begin
if NMFTP1.Connected then
begin
  if InputQuery('Crear Directorio', 'Nombre Directorio ?',Dir) then
  begin
     NMFTP1.MakeDirectory(Dir);
     Memo1.Lines.Add('Directorio Creado . . .');
     Directorios;
  end;
end;
end;

procedure TForm1.NMFTP1PacketSent(Sender: TObject);
begin
StatusBar1.SimpleText := 'Cargando: ' + ShellListView1.SelectedFolder.PathName +
' ' + IntToStr(NMFTP1.BytesRecvd) + ' of '+IntToStr(NMFTP1.BytesTotal);
end;

procedure TForm1.SpeedButton3Click(Sender: TObject);
begin
  if ShellListView1.SelectedFolder.IsFolder = False then
  begin
      Memo1.Lines.Add('Cargando Archivo a Directorio Remoto . . .');
      ListBox3.Items.Add('Carga....  ' + ShellListView1.SelectedFolder.PathName);
      try
      begin
         NMFTP1.Upload(ShellListView1.SelectedFolder.PathName,'');
         Directorios;
         Memo1.Lines.Add('La carga del Archivo ha terminado . . .');
      end;
      except
         Memo1.Lines.Add('Ocurrio un error duarante la carga. Intente de Nuevo . . .');
         StatusBar1.SimpleText := 'Error en la Carga . . .';
      end;
  end;
end;

procedure TForm1.SpeedButton4Click(Sender: TObject);
begin
Form1.ListBox2DblClick(Sender);
end;

procedure TForm1.Salir1Click(Sender: TObject);
begin
Application.Terminate;
end;

procedure TForm1.Conectar1Click(Sender: TObject);
begin
SpeedButton1.Click;
end;

procedure TForm1.Desconectar1Click(Sender: TObject);
begin
SpeedButton2.Click;
end;

procedure TForm1.Cargar1Click(Sender: TObject);
begin
SpeedButton3.Click;
end;

procedure TForm1.Descargar2Click(Sender: TObject);
begin
SpeedButton4.Click;
end;

procedure TForm1.Acercade1Click(Sender: TObject);
begin
ShellAbout (Handle,'Ejemplo de Cliente Ftp.','Programador: Pablo Bustos Fernndez.',Application.Icon.Handle);
end;

end.
